﻿//Copyright Warren Clayton Harding 2015
//Released to the public domain
//under the Ms-pl
//Please leave this copyright notice intact
using System;

namespace Servo
{
    //You probably won't instantiate this class directly, but you should set the maxForce variable below
    //you can use this directly if you know the acceleration you want.
    public class AccelerationServo
    {
        public Double lastAcceleration=1;
        public Double lastVelocity = 0;
        public Double lastForce=1;
        public Double maxForce = 5; //this relates directly to the maximum power available from your motor and should be set when starting
        public Double approximateExpectedMass = 1;
        //returns a force
        public Double Force(Double velocity,Double inTargetAcceleration, Double elapsedTime)
        {
            Double calculatedMassLikeResistance = Math.Abs(lastForce / lastAcceleration);
            if (Double.IsNaN(calculatedMassLikeResistance))
            {
                calculatedMassLikeResistance = approximateExpectedMass;
            }
            Double force = calculatedMassLikeResistance * inTargetAcceleration;
            if (Math.Abs(force) > maxForce)
            {
                force = maxForce * Math.Sign(force);
            }
            Double deltaVelocity = velocity - lastVelocity;
            lastAcceleration = deltaVelocity / elapsedTime;
            lastVelocity = velocity;
            lastForce = force;
            return force;
        }
    }
}