﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using Servo;
using System.Timers;
namespace ServoTest
{
    /// <summary>
    /// Interaction logic for VelocityTest.xaml
    /// </summary>
    public partial class VelocityTest : Window
    {
        Ellipse shapeEllipse;
        Timer timer = new Timer();
        public VelocityTest()
        {
            InitializeComponent();

            shapeEllipse = new Ellipse();
            shapeEllipse.Stroke = System.Windows.Media.Brushes.Black;
            shapeEllipse.Fill = System.Windows.Media.Brushes.DarkBlue;
            shapeEllipse.Width = 50;
            shapeEllipse.Height = 50;
            canvas1.Children.Add(shapeEllipse);
            Canvas.SetLeft(shapeEllipse, 300);

            timer.Elapsed += timer_Elapsed;

            this.Closing += MainWindow_Closing;
        }


        void MainWindow_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            timer.Enabled = false;
            System.Threading.Thread.Sleep(100);
        }


        VelocityServo velocityServo = new VelocityServo();
        Double targetVelocity = 10f;
        Double timeStep = 1f / 50f;
        Double mass = 1f;
        Double acceleration = 0;
        Double velocity = 0;
        Double position = 100;
        Boolean isBusy = false;
        void timer_Elapsed(object sender, ElapsedEventArgs e)
        {
            if (isBusy == true)
            {
                return;
            }
            isBusy = true;
            Double force = velocityServo.Force(velocity, targetVelocity, timeStep);
            acceleration = force / mass;
            velocity += acceleration * timeStep;
            position += velocity * timeStep;
            this.Dispatcher.Invoke(() => Canvas.SetLeft(shapeEllipse, position));
            count++;
            if (count == 25)
            {
                this.Dispatcher.Invoke(() => this.lblVelocity.Content = velocity.ToString());
                count = 0;
            }
            isBusy = false;
        }
        int count = 0;

        private void btnStart_Click_1(object sender, RoutedEventArgs e)
        {
            timer.Interval = timeStep;
            timer.Enabled = true;
        }

        private void btnStop_Click_1(object sender, RoutedEventArgs e)
        {
            timer.Enabled = false;
        }
    }
}
